#!/bin/sh

# This script is invoked from cloud-agent
# DO NOT write anything other than AgentUUID to stdout in non-error path

HOST_ID_DIR=$2
AGENT_UUID=$3

group=`cat /etc/qualys/cloud-agent/qualys-cloud-agent.conf | grep "^UserGroup=" | awk -F= '{print $2}'`
user=root

if [ -z "$HOST_ID_DIR" ];then
        echo "Invalid HOST_ID_DIR"
        exit 1
fi

if [ "$1" = "1" ] ; then

    if [ -z "$AGENT_UUID" ];then
                echo "Invalid AGENT_UUID"
                exit 1
        fi

        if [ ! -d "$HOST_ID_DIR" ]; then
                mkdir "$HOST_ID_DIR"
        fi
        
 		chmod 770 "$HOST_ID_DIR"
        echo $AGENT_UUID > "$HOST_ID_DIR/hostid"
        chmod 660 "$HOST_ID_DIR/hostid"
	if [ ! -z "$group" -a "$group" != " " ]; then
		chown ${user} "$HOST_ID_DIR/hostid";
		chgrp -H ${group} "$HOST_ID_DIR/hostid";
	fi
fi

if [ ! -f "$HOST_ID_DIR/hostid" ];then
        #check the permission on dir
        #mkdir $HOST_ID_DIR 2>/dev/null
        chmod 770 "$HOST_ID_DIR" 2>/dev/null
        touch "$HOST_ID_DIR/hostid"
        chmod 660 "$HOST_ID_DIR/hostid"
	if [ ! -z "$group" -a "$group" != " " ]; then
		chown ${user} "$HOST_ID_DIR/hostid";
		chgrp -H ${group} "$HOST_ID_DIR/hostid";
	fi
        exit $?
fi

cat "$HOST_ID_DIR/hostid"
